--- compat/linux/linux_misc.c	Tue Aug 15 12:54:29 2006
+++ compat/linux/linux_misc.c	Tue Aug 15 15:09:22 2006
@@ -1334,6 +1334,7 @@
 int
 linux_getpid(struct thread *td, struct linux_getpid_args *args)
 {
+#ifdef __i386__
    	struct linux_emuldata *em;
 
 	em = em_find(td->td_proc, EMUL_UNLOCKED);
@@ -1342,6 +1343,9 @@
 
 	td->td_retval[0] = em->shared->group_pid;
 	EMUL_UNLOCK(&emul_lock);
+#else
+	td->td_retval[0] = td->td_proc->p_pid;
+#endif
 	return (0);
 }
 
@@ -1361,6 +1365,7 @@
 int
 linux_getppid(struct thread *td, struct linux_getppid_args *args)
 {
+#ifdef	__i386__
    	struct linux_emuldata *em;
 	struct proc *p, *pp;
 
@@ -1393,7 +1398,9 @@
 
 	EMUL_UNLOCK(&emul_lock);
 	PROC_UNLOCK(pp);
-
+#else
+	return getppid(td, (struct getppid_args *) args);
+#endif
 	return (0);
 }
 
